#include "inet.h"

#include <netdb.h>

#if defined(powerc)
#include <compat.h>
#endif

#include <GUSI.h>
#include <compat.h>

#ifndef INADDR_NONE
#define INADDR_NONE  0xffffffff
#endif

u_short         portbase = 0;




/*--------------------------------------------------------------------------
Name: int OpenSock(char *host, char *service, char *protocol,
                   struct sockaddr_in  *inaddr, int port)
Out: sockfd
Comments: This function opens a socket on the specified host at the specified
          port. Returns -1 in case of failure.
--------------------------------------------------------------------------*/
int             OpenSock(char *host, char *service, char *protocol,
                   struct sockaddr_in * inaddr, int port)
{

   struct hostent *hse;         /* pointer to host information entry */
   struct servent *pse;         /* pointer to service information entry */
   struct protoent *ppe;        /* pointer to protocol information entry */

   /* in /etc/protocols */

#if defined(powerc)
   struct in_addr  ddaddr;

#else
   unsigned long   ddaddr;      /* dotted-decimal number for host name */

#endif
   int             sockfd, type;

   bzero((char *) inaddr, sizeof(*inaddr));
   inaddr->sin_family = AF_INET;

   inaddr->sin_port = htons(port);

   if (host != NULL)
   {                            /* get host IP address */

#if 0
      printf("OpenSock(): host = %s\n", host);
#endif

      if (hse = gethostbyname(host))
      {
         memcpy(&ddaddr, hse->h_addr, sizeof(struct in_addr));

#if 0
         printf("# gethostbyname(%s) returned %s\n", host, inet_ntoa(ddaddr));
#endif
      }
      else
      {
         ddaddr = inet_addr(host);
      }

#if 0
      fflush(stdout);
#endif

      inaddr->sin_addr.s_addr = ddaddr.s_addr;
   }
   else
   {
      inaddr->sin_addr.s_addr = INADDR_ANY;     /* Receive at well know port */
      /* at any IP address on machine */
   }

   if ((ppe = getprotobyname(protocol)) == NULL)        /* get protocol number */
      printf("ERROR: Can't get protocol entry %s\n", protocol);

   if (strcmp(protocol, "tcp") == 0)    /* set socket type */
      type = SOCK_STREAM;
   else
      type = SOCK_DGRAM;

#if 0
   printf("protocol = %d\n", ppe->p_proto);
#endif

   sockfd = socket(AF_INET, type, ppe->p_proto);        /* allocate socket */
   if (sockfd < 0)
      printf("ERROR: Can't create socket \n");

#if 0
   printf("sockfd = %d\n", sockfd);
#endif

   return (sockfd);

}
